# $Id: Network.pm,v 1.6 2001/11/19 23:53:23 pbaltz Exp $
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.
#
# hidden functions only used by scripts in this module

package Network;

require Exporter;

use vars qw(@ISA @EXPORT_OK);

@ISA = qw(Exporter);
@EXPORT_OK = qw(find_eth_ifaces $NET_SCRIPTS_DIR);

# files and directories
$Network::NET_SCRIPTS_DIR = '/etc/sysconfig/network-scripts';
$Network::ETC_HOSTS = '/etc/hosts';

# programs
$Network::IFCONFIG = '/sbin/ifconfig';
$Network::ROUTE = '/sbin/route';

# exportable routines

# find the interface names for all real and alias interfaces
sub find_eth_ifaces
{
    my @eth_ifaces = ();

    # first find real physical intefaces
	if (defined(open(IFCONFIG, "$Network::IFCONFIG -a 2>/dev/null |")))
	{
		while (<IFCONFIG>)
		{
			if (!/^(eth\d+)\s/) { next; }
			# found an existing interface
			push @eth_ifaces, $1;
		}
		close(IFCONFIG);
    }
	else
	{
		return ();
	}

    # now search /etc/sysconfig/network-scripts for aliases
    if (opendir(IFCFG, $Network::NET_SCRIPTS_DIR))
    {
        while (my $filename = readdir(IFCFG))
        {
            if ($filename =~ /\-(eth\d+\:\d+)$/)
            {
                push @eth_ifaces, $1;
            }
        }
        
        closedir(IFCFG);
    }
    else
    {
        return ();
    }

    return @eth_ifaces;
}
