#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: cleanup_aliases.pl,v 1.1 2001/12/04 07:25:08 pbaltz Exp $
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.
#
# if a real interface has just changed IP addresses to that of an alias
# cleanup the alias

use CCE;

my $cce = new CCE;
$cce->connectfd();

my $network = $cce->event_object();

# if this Network object is not real or not enabled, just succeed
if (!$network->{ipaddr} || !$network->{real} || !$network->{enabled})
{
	$cce->bye('SUCCESS');
	exit(0);
}

# check for aliases
my @aliases = $cce->find('Network',
				{
					'ipaddr' => $network->{ipaddr},
					'real' => 0,
					'enabled' => 1
				});

for (my $i = 0; $i < scalar(@aliases); $i++)
{
	my ($ok) = $cce->set($aliases[$i], '', { 'enabled' => 0 });
	($ok) = $cce->destroy($aliases[$i]);
	if (!$ok)
	{
		$cce->bye('FAIL');
		exit(1);
	}
}

$cce->bye('SUCCESS');
exit(0);
