#!/usr/bin/perl -I/usr/sausalito/perl
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.
# $Id: enforce_deps.pl,v 1.1 2001/09/06 03:12:42 pbaltz Exp $
#
# enforce dependencies when attempting to disable an interface
# this checks that there are no aliases or static routes that depend on
# an interface being enabled before allowing an interface to be disabled

use CCE;

my $cce = new CCE;
$cce->connectfd();

my $eth = $cce->event_object();

# aliases shouldn't have static routes and can't have aliases
if (!$eth->{real} || $eth->{enabled})
{
    $cce->bye('SUCCESS');
    exit(0);
}

# check for static routes
if (scalar($cce->findx('Route', { 'device' => $eth->{device} })))
{
    $cce->bye('FAIL', '[[base-network.ifaceUsedByRoute]]');
    exit(1);
}

# check for aliases
if (scalar($cce->findx('Network', { 'real' => 0 }, 
                        { 'device' => "^$eth->{device}" })))
{
    $cce->bye('FAIL', '[[base-network.ifaceUsedByAlias]]');
    exit(1);
}

$cce->bye('SUCCESS');
exit(0);

