#!/usr/bin/perl -w -I/usr/sausalito/perl -I. -I/usr/sausalito/handlers/base/network
# $Id: getmac.pl,v 1.4 2001/11/20 18:44:11 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.

# getmac.pl
# get the mac address for this interface

use CCE;
use Network;

my $DEBUG = 0;

# apparently the ethernet drivers are modules now, so we need
# to run ifconfig to get the modules loaded before getting the MACs
# don't run ifconfig because the mac address should come up
# when ifconfig'ing the interface itself
# system("/sbin/ifconfig -a >/dev/null 2>&1");

my $cce = new CCE;
$cce->connectfd();

my $oid = $cce->event_oid();
my $obj = $cce->event_object();
my $device = $obj->{'device'};

# get the inteface information from ifconfig
my $data = `$Network::IFCONFIG $device`;

# only accept valid hexadecimal digits
my $hex = '[0-9a-fA-F]{2,}';
if ($data =~ m/HWaddr ($hex:$hex:$hex:$hex:$hex:$hex)/) 
{
    my $mac = $1;
    $DEBUG && print STDERR "mac address for device $device: $mac\n";
    my ($ok) = $cce->set($oid, '', { 'device' => $device, 'mac' => $mac });
    if (not $ok)
    {
        $cce->bye('FAIL', '[[base-network.cantSetMacAddress]]');
        exit(1);
    }
}

$cce->bye('SUCCESS');
exit(0);
