#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/network
# $Id: range_ok.pl,v 1.1 2001/08/24 00:26:35 jcheng Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# Given an IPPoolingRange object, checks that both min and max are
# present, and that min <= max,

use CCE;
use IpPooling;

my $cce = new CCE('Domain' => 'base-network');
$cce->connectfd();

my $old = $cce->event_old();
my $object = $cce->event_object();
my $new = $cce->event_new();

if (!$object->{min} || !$object->{max}) {
    $cce->warn('missing_part_of_range');
    $cce->bye('FAIL');
    exit 1;
}

if (IpPooling::ippool_get_canonical($object->{min}) > IpPooling::ippool_get_canonical($object->{max})) {
    $cce->warn('minGreaterThanMax', { 'range_min' => $object->{min}, 'range_max' => $object->{max}});
    $cce->bye('FAIL');
    exit 1;
}

if ($cce->event_is_create()) {
    $cce->set($cce->event_oid(), '', { 'creation_time' => time });
}

$cce->bye('SUCCESS');
exit 0;

