#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: set_imode.pl,v 1.3 2001/06/13 17:40:44 will Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
# This should only do anything if the network has been reset and the machine
# is currently rebooting.  Hopefully, dns servers will be set before this runs,
# otherwise this could cause dns to be enabled.
# 
use CCE;

my $cce = new CCE;
$cce->connectfd();

my $system = $cce->event_object();
my ($ok, $sysnet) = $cce->get($cce->event_oid(), 'Network');

if (not $ok) 
{
    $cce->bye('FAIL');
    exit(1);
}

# set the internetMode correctly if the gateway is specified
if (($sysnet->{internetMode} eq 'none') 
        && $system->{gateway} && ($system->{gateway} ne '0.0.0.0')) 
{
    ($ok) = $cce->set($cce->event_oid(), 'Network', { 'internetMode' => 'lan' });

    if (not $ok) 
    {
        $cce->bye('FAIL');
        exit(1);
    }
}

$cce->bye('SUCCESS');
exit(0);

