#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/network
# $Id: validate_pool.pl,v 1.1 2001/08/24 00:26:36 jcheng Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
# 

use CCE;
use IpPooling;

my $cce = new CCE('Domain' => 'base-network', 'Namespace' => 'Network');
$cce->connectfd();

my $network = $cce->event_object();

if ($network->{pooling}) {
    my (@oids) = $cce->findx('IPPoolingRange');
    my @range_oids = ();
    
    # get ranges
    foreach $a_oid (@oids) {
	my ($ok, $range) = $cce->get($a_oid);
	push @ranges, $range;
    }
    
    # get networks
    my (@network_oids) = $cce->findx('Network', { 'enabled' => 1 });
    foreach my $oid (@network_oids) {
	my ($ok, $net) = $cce->get($oid);
	if (!$ok) {
	    $cce->bye('FAIL');
	    exit 1;
	}
	push @ips, $net->{ipaddr};
    }

    my (@error_ips) = IpPooling::validate_pooling_state(\@ranges, \@ips);
    if (@error_ips) {
	$cce->warn('cant_enable_pooling', { 'ips_not_covered' => join(',', @error_ips)});
	$cce->bye('FAIL');
	exit 1;
    }
}

$cce->bye('SUCCESS');
exit 0;
